-----------------------------------------------------------------------------
-- Assump:	Assumptions
-- 
-- Part of `Typing Haskell in Haskell', version of September 1, 1999
-- Copyright (c) Mark P Jones and the Oregon Graduate Institute
-- of Science and Technology, 1999
-- 
-- This program is distributed as Free Software under the terms
-- in the file "License" that is included in the distribution
-- of this software, copies of which may be obtained from:
--             http://www.cse.ogi.edu/~mpj/thih/
-- 
-----------------------------------------------------------------------------

module Assump where
import Id
import Scheme
import Subst
import PPrint

data Assump = Id :>: Scheme

instance PPrint Assump where
  pprint (i :>: s) = (text (show i) <+> text ":>:") $$ nest 2 (pprint s)

instance Types Assump where
  apply s (i :>: sc) = i :>: (apply s sc)
  tv (i :>: sc)      = tv sc

find     :: Id -> [Assump] -> Scheme
find i as = head [ sc | (i':>:sc) <- as, i==i' ]

-----------------------------------------------------------------------------
